/*
 * Copyright (c) 2008 - 2020 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 * 
 * Licensed under the HARK license, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * https://www.hark.jp/notice/HARK_License_Agreement.pdf
 */

#ifndef VOICE_CANCEL_H_
#define VOICE_CANCEL_H_
#include <stdlib.h>
#include <vector>
#include <beattracker/fft_analysis.h>
#include <beattracker/fd_ica.h>

class VoiceCancel {
public:
    VoiceCancel(size_t window_size);
    ~VoiceCancel();
    int ExecuteVoiceCancel(const std::vector<FftComplex> self_voice_spec,const std::vector<FftComplex> mic_spec, std::vector<double> &voice_canceled_spec);
private:
    double **s_y, **s_x, **s_d;
    SemiBlind *semiblind_ica_;
    const size_t window_size_;
};


#endif /* VOICE_CANCEL_H_ */
